package jiaowuxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/ctx"
	"shylinux.com/x/icebergs/base/mdb"
	"shylinux.com/x/toolkits"

	"shylinux.com/x/education/src/jiaowuxitong/model"
)

type portal struct {
	ice.Hash
	Class       Class
	userClass   userClass
	export      string `data:"true"`
	short       string `data:"index"`
	field       string `data:"time,name,icons,index,order,enable"`
	list        string `name:"list class_uid index uid auto" role:"void"`
	classCreate string `name:"classCreate school_uid* grade* name*" role:"void"`
	classRemove string `name:"classRemove class_uid*" role:"void"`
}

func (s portal) Inputs(m *ice.Message, arg ...string) {
	s.Class.Inputs(m, arg...)
}
func (s portal) List(m *ice.Message, arg ...string) {
	if len(arg) == 0 {
		m.Cmdy(s.userClass, s.userClass.MyClass, s.UserUID(m)).Action(s.ClassCreate).PushAction(s.ClassRemove)
		kit.If(m.Length() == 0, func() { m.EchoInfoButton(m.Trans("Please Create Your Class", "请创建班级"), s.ClassCreate) })
	} else if len(arg) == 1 {
		s.Hash.List(m, arg[1:]...).SortInt(mdb.ORDER)
	} else if len(arg) == 2 {
		m.Cmdy(ctx.COMMAND, arg[1]).Push(ctx.ARGS, arg[0])
	} else {
		m.FieldsSetDetail().Cmdy(arg[1], mdb.SELECT, model.UID, arg[2]).PushAction().Action()
	}
	m.Display("").DisplayCSS("")
}
func (s portal) ClassCreate(m *ice.Message, arg ...string) {
	if !m.Cmdy(s.Class, s.Class.Create, arg).IsErr() {
		m.Cmdy(s.userClass, s.userClass.Create, model.USER_UID, s.UserUID(m), model.CLASS_UID, m.Result())
	}
}
func (s portal) ClassRemove(m *ice.Message, arg ...string) {
	m.Cmdy(s.Class, s.Class.Delete, model.UID, m.Option(model.CLASS_UID))
	m.Cmdy(s.userClass, s.userClass.Delete, model.USER_UID, s.UserUID(m), model.CLASS_UID, m.Option(model.CLASS_UID))
}

func init() { ice.Cmd(prefixKey(), portal{}) }

func (s portal) UserUID(m *ice.Message) string {
	return m.Option(ice.MSG_USERNAME)
}
func (s portal) Show(m *ice.Message, arg ...string) {
	cmd := m.GetCommand()
	m.Cmd(s, s.Create, mdb.NAME, cmd.Help, mdb.ICONS, cmd.Icon, ctx.INDEX, m.PrefixKey())
}
